/*
 * Applet.java:  a packable applet 
 *
 * Copyright (c) 2000, 2002 Nozomi `James' Ytow
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * Where this Software is combined with software released under the terms of 
 * the GNU Public License ("GPL") and the terms of the GPL would require the 
 * combined work to also be released under the terms of the GPL, the terms
 * and conditions of this License will apply in addition to those of the
 * GPL with the exception of any terms or conditions of this License that
 * conflict with, or are expressly prohibited by, the GPL.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 * $Id: Applet.java,v 1.2 2002/08/01 04:18:17 nozomi Exp $
 * $Log: Applet.java,v $
 * Revision 1.2  2002/08/01 04:18:17  nozomi
 * remove getFrame method
 *
 * Revision 1.1.1.1  2002/01/16 12:33:34  ryo
 * initial import into CVS
 */

package org.nomencurator.applet;    

import java.awt.Container;
import java.awt.Dimension;

import jp.kyasu.awt.Frame;

/**
 * The <code>Applet</code> class implements a pakcable applet as an extension
 * of java.applet.Applet.
 *
 * @see 	java.applet.Applet
 *
 * @version 	01 Aug 2002
 * @author 	Nozomi `James' Ytow
 */

public class Applet 
    //    extends java.applet.Applet
    extends jp.kyasu.awt.Applet
{
    
    static boolean hasGetSize = true;

    /*
    static {
	jp.kyasu.awt.Applet applet = new jp.kyasu.awt.Applet();
	try {
	    getSize();
	}
	catch (Throwable t0){
	    hasGetSize = false;
	}
    }
    */

    public Applet()
    {
	super();
    }


    /**
     * Constructs a packable applet.
     *
     */
    public void init()
    {
	super.init();
	/*
	try{
	    getSize();
	}
	catch (Throwable t0){
	*/
	    hasGetSize = false;
	    /*
	}
	    */
    }
    
    /**
     * getSize() wrapper for Java VM without getSize().
     *
     */
    public Dimension getSize(){
	/*
	if(hasGetSize)
	    return super.getSize();
	else
	*/
	    return size();
    }

    /**
     * pack the applet.
     *
     */
    public void pack() {
	Container parent = getParent();
	if (parent != null){
	    boolean packable;
	    try{
		packable = parent.isDisplayable();
	    }
	    catch(Throwable e){
		packable = (null != parent.getPeer());
	    }
	    
	    if(packable){
		parent.addNotify();
		addNotify();
	    }
	}
	setSize(getPreferredSize());
	validate();
    }
    /*
    public Frame getFrame()
    {
	Container parent = getParent();
	while(parent != null && !(parent instanceof Frame))
	    parent = parent.getParent();
	return (Frame)parent;
    }
    */
}
