/*
 * LinkRecord.java: 
 *
 * Copyright (c) 2002 Hiroyuki Okawa
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * Where this Software is combined with software released under the terms of 
 * the GNU Public License ("GPL") and the terms of the GPL would require the 
 * combined work to also be released under the terms of the GPL, the terms
 * and conditions of this License will apply in addition to those of the
 * GPL with the exception of any terms or conditions of this License that
 * conflict with, or are expressly prohibited by, the GPL.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 * $Id: LinkRecord.java,v 1.5 2002/06/07 14:07:51 ryo Exp $
 * $Log: LinkRecord.java,v $
 * Revision 1.5  2002/06/07 14:07:51  ryo
 * add id and its accessor
 *
 * Revision 1.4  2002/04/01 06:48:31  nozomi
 * use java.util.Vector
 *
 * Revision 1.3  2002/03/28 06:29:41  okawa
 * add copyright
 *
 * Revision 1.2  2002/02/22 10:54:51  okawa
 * initial import into CVS
 *
 *
 */

package org.nomencurator.controller.linktable;

import java.util.Vector;
import java.util.Enumeration;

public class LinkRecord
{

    protected String fromOid;
    protected String toOid;
    protected String id;
    
	/**
	 * Constractor
	 * @param String from oid
	 * @param String to oid
	 */
    public LinkRecord(String from, String to) {
    	this(from, to, null);
    }

	/**
	 * Constractor
	 * @param String from oid
	 * @param String to oid
	 * @param String id
	 */
    public LinkRecord(String from, String to, String id) {
        this.fromOid = from;
        this.toOid = to;
        this.id = id;
    }

	/**
	 * get FROM oid
	 * @return String
	 */
	public String getFrom() {
	    return fromOid;
    }

	/**
	 * set FROM oid
	 * @param String
	 */
	public void setFrom(String fromOid) {
	    this.fromOid = fromOid;
    }

	/**
	 * get TO oid
	 * @return String
	 */
	public String getTo() {
	    return toOid;
    }

	/**
	 * set TO oid
	 * @param String
	 */
	public void setTo(String toOid) {
	    this.toOid = toOid;
    }

	/**
	 * get id
	 * @return String
	 */
	public String getID() {
	    return id;
    }

	/**
	 * set id
	 * @param String
	 */
	public void setID(String id) {
	    this.id = id;
    }

	/**
	 * return string value of this object
	 * @return String
	 */
	public String toString() {
	    return fromOid + "-" + toOid;
    }

}
