/*
 * AppearanceEditor.java:  an interface of AppearanceEditor
 * for TaxoNote based on Nomencurator data model
 *
 * Copyright (c) 2001, 2002 Nozomi `James' Ytow
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * Where this Software is combined with software released under the terms of 
 * the GNU Public License ("GPL") and the terms of the GPL would require the 
 * combined work to also be released under the terms of the GPL, the terms
 * and conditions of this License will apply in addition to those of the
 * GPL with the exception of any terms or conditions of this License that
 * conflict with, or are expressly prohibited by, the GPL.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 * $Id: AppearanceEditor.java,v 1.2 2002/02/24 18:13:36 nozomi Exp $
 * $Log: AppearanceEditor.java,v $
 * Revision 1.2  2002/02/24 18:13:36  nozomi
 * re-implementation of setModel() to be used switching between models
 *
 * Revision 1.1  2002/01/29 06:48:21  nozomi
 * initial import into CVS
 *
 */

package org.nomencurator.editor;

import org.nomencurator.Appearance;

import org.nomencurator.editor.model.AppearanceEditModel;

/**
 * Interface for graphical component wrapping
 * <code>AppearanceEditModel</code>.
 *
 * @see org.nomencurator.editor.model.AppearanceEditModel
 * @see org.nomencurator.Appearance
 *
 * @version 	24 Feb 2002
 * @author 	Nozomi `James' Ytow
 */
public interface AppearanceEditor
    extends NamedObjectEditor
{
    /**
     * Returns <code>AppearanceEditModel</code> in use
     */ 
    public AppearanceEditModel getAppearanceEditModel();

    /**
     * Returns <code>Appearance</code> handled by this editor
     */
    public Appearance getAppearance();

    /**
     * Sets <code>Appearance</code> to behandled by this editor
     *
     * @param appearance <code>Appearance</code> to behandled by this editor
     */
    public void setAppearance(Appearance appearance);
}
